(require 'char-fold)

(setq char-fold-symmetric t)

;; Allow searching with Cyrillic translit
;; https://en.wikipedia.org/wiki/Transliteration
;; https://en.wikipedia.org/wiki/Romanization_of_Russian#Transliteration_table
(setq char-fold-include
      (append char-fold-include
              '((?а "a")
                (?б "b")
                (?в "v" "w")
                (?г "g")
                (?д "d")
                (?е "e")
                (?ё "jo" "yo")
                (?ж "zh")
                (?з "z")
                (?и "i")
                (?й "j" "y")
                (?к "k")
                (?л "l")
                (?м "m")
                (?н "n")
                (?о "o")
                (?п "p")
                (?р "r")
                (?с "s")
                (?т "t")
                (?у "u")
                (?ф "f")
                (?х "h")
                (?ц "c")
                (?ч "ch")
                (?ш "sh")
                (?щ "sch")
                (?ы "y")
                (?э "e")
                (?ю "ju" "yu")
                (?я "ja" "ya"))))

;; Also allow search to match accented Cyrillic chars, so e.g. in etc/HELLO
;; “Здравствуйте” will match “Здра́вствуйте” and vice versa:
(setq char-fold-include
      (append char-fold-include
              '((?а "а́") (?А "А́")
                (?е "е́") (?Е "Е́")
                (?и "и́") (?И "И́")
                (?о "о́") (?О "О́")
                (?у "у́") (?У "У́")
                (?ы "ы́") (?Ы "Ы́")
                (?э "э́") (?Э "Э́")
                (?ю "ю́") (?Ю "Ю́")
                (?я "я́") (?Я "Я́"))))

(char-fold-update-table)
